My Project: dgCollisionScene Class Reference

My Project

Public Member Functions | List of all members
dgCollisionScene Class Reference

`#include <dgCollisionScene.h>`

Inheritance diagram for dgCollisionScene:

## Public Member Functions

| dgCollisionScene (dgWorld *const world)
| dgCollisionScene (const dgCollisionScene &source, const dgCollisionInstance *const myInstance)
| dgCollisionScene (dgWorld *const world, dgDeserialize deserialization, void *const userData, const dgCollisionInstance *const myInstance)
virtual | ~dgCollisionScene ()
void | CollidePair (dgCollidingPairCollector::dgPair *const pair, dgCollisionParamProxy &proxy) const
void | CollideCompoundPair (dgCollidingPairCollector::dgPair *const pair, dgCollisionParamProxy &proxy) const
virtual void | MassProperties ()
virtual void | Serialize (dgSerialize callback, void *const userData) const
dgFloat32 | GetBoxMinRadius () const
dgFloat32 | GetBoxMaxRadius () const
Public Member Functions inherited from dgCollisionCompound
| dgCollisionCompound (dgWorld *const world)
| dgCollisionCompound (const dgCollisionCompound &source, const dgCollisionInstance *const myInstance)
| dgCollisionCompound (dgWorld *const world, dgDeserialize deserialization, void *const userData, const dgCollisionInstance *const myInstance)
void | SetParent (const dgCollisionInstance *const myInstance)
virtual | ~dgCollisionCompound ()
virtual void | BeginAddRemove ()
virtual dgTreeArray::dgTreeNode * | AddCollision (dgCollisionInstance *const part)
virtual void | RemoveCollision (dgTreeArray::dgTreeNode *const node)
virtual void | SetCollisionMatrix (dgTreeArray::dgTreeNode *const node, const dgMatrix &matrix)
virtual void | EndAddRemove (bool flushCache=true)
void | ApplyScale (const dgVector &scale)
void | GetAABB (dgVector &p0, dgVector &p1) const
dgInt32 | GetNodeIndex (dgTreeArray::dgTreeNode *const node) const
dgTreeArray::dgTreeNode * | FindNodeByIndex (dgInt32 index) const
dgTreeArray::dgTreeNode * | GetFirstNode () const
dgTreeArray::dgTreeNode * | GetNextNode (dgTreeArray::dgTreeNode *const node) const
dgCollisionInstance * | GetCollisionFromNode (dgTreeArray::dgTreeNode *const node) const
Public Member Functions inherited from dgCollision
dgInt32 | IsType (dgRTTI type) const
dgUnsigned32 | GetSignature () const
dgCollisionID | GetCollisionPrimityType () const
virtual dgFloat32 | GetSkinThickness () const
virtual void | SerializeLow (dgSerialize callback, void *const userData) const
virtual dgInt32 | GetConvexVertexCount () const
const dgCollision * | AddRef () const
dgInt32 | GetRefCount () const
virtual dgInt32 | Release () const
const dgVector & | GetObbOrigin () const
virtual dgVector | GetObbSize () const
dgFloat32 | GetUmbraClipSize () const
dgMemoryAllocator * | GetAllocator () const

## Additional Inherited Members

Public Types inherited from dgCollision

enum

dgRTTI {
dgCollisionNull_RTTI = 1<<0, dgCollisionBox_RTTI = 1<<1, dgCollisionCone_RTTI = 1<<2, dgCollisionSphere_RTTI = 1<<3,
dgCollisionCapsule_RTTI = 1<<4, dgCollisionCylinder_RTTI = 1<<5, dgCollisionConvexHull_RTTI = 1<<6, dgCollisionTaperedCapsule_RTTI = 1<<7,
dgCollisionTaperedCylinder_RTTI = 1<<8, dgCollisionChamferCylinder_RTTI = 1<<9, dgCollisionConvexPolygon_RTTI = 1<<10, dgCollisionConvexShape_RTTI = 1<<11,
dgCollisionCompound_RTTI = 1<<12, dgCollisionBVH_RTTI = 1<<13, dgCollisionMesh_RTTI = 1<<14, dgCollisionDeformableMesh_RTTI = 1<<15,
dgCollisionDeformableSolidMesh_RTTI = 1<<16, dgCollisionDeformableClothPatch_RTTI = 1<<17, dgCollisionUserMesh_RTTI = 1<<18, dgCollisionHeightField_RTTI = 1<<19,
dgCollisionScene_RTTI = 1<<20, dgCollisionCompoundBreakable_RTTI = 1<<21
}

typedef void(dgApi * | OnDebugCollisionMeshCallback) (void *userData, int vertexCount, const dgFloat32 *FaceArray, int faceId)
Static Public Member Functions inherited from dgCollision
static dgUnsigned32 | Quantize (dgFloat32 value)
static dgUnsigned32 | Quantize (void *buffer, int size)
Public Attributes inherited from dgCollisionCompound
DG_MSC_VECTOR_ALIGMENT class dgCollisionCompound::dgOOBBTestData | DG_GCC_VECTOR_ALIGMENT
DG_MSC_VECTOR_ALIGMENT class dgCollisionCompound::dgNodeBase | DG_GCC_VECTOR_ALIGMENT
Protected Types inherited from dgCollisionCompound
enum | dgNodeType { m_leaf, m_node }
Protected Member Functions inherited from dgCollisionCompound
void | RemoveCollision (dgNodeBase *const node)
virtual dgFloat32 | GetVolume () const
virtual dgVector | SupportVertex (const dgVector &dir, dgInt32 *const vertexIndex) const
virtual void | CalcAABB (const dgMatrix &matrix, dgVector &p0, dgVector &p1) const
dgMatrix | CalculateInertiaAndCenterOfMass (const dgMatrix &m_alignMatrix, const dgVector &localScale, const dgMatrix &matrix) const
dgFloat32 | CalculateMassProperties (const dgMatrix &offset, dgVector &inertia, dgVector &crossInertia, dgVector &centerOfMass) const
virtual dgVector | CalculateVolumeIntegral (const dgMatrix &globalMatrix, const dgVector &plane, const dgCollisionInstance &parentScale) const
virtual void | DebugCollision (const dgMatrix &matrix, dgCollision::OnDebugCollisionMeshCallback callback, void *const userData) const
virtual dgFloat32 | RayCast (const dgVector &localP0, const dgVector &localP1, dgFloat32 maxT, dgContactPoint &contactOut, const dgBody *const body, void *const userData, OnRayPrecastAction preFilter) const
virtual dgFloat32 | ConvexRayCast (const dgCollisionInstance *const instance, const dgMatrix &instanceMatrix, const dgVector &instanceVeloc, dgFloat32 maxT, dgContactPoint &contactOut, const dgBody *const referenceBody, const dgCollisionInstance *const referenceInstance, void *const userData, dgInt32 threadId) const
virtual dgInt32 | CalculateSignature () const
virtual void | SetCollisionBBox (const dgVector &p0, const dgVector &p1)
virtual void | GetCollisionInfo (dgCollisionInfo *const info) const
virtual dgInt32 | CalculateContacts (dgCollidingPairCollector::dgPair *const pair, dgCollisionParamProxy &proxy) const
dgInt32 | CalculateContactsToSingle (dgCollidingPairCollector::dgPair *const pair, dgCollisionParamProxy &proxy) const
dgInt32 | CalculateContactsToSingleContinue (dgCollidingPairCollector::dgPair *const pair, dgCollisionParamProxy &proxy) const
dgInt32 | CalculateContactsToCompound (dgCollidingPairCollector::dgPair *const pair, dgCollisionParamProxy &proxy) const
dgInt32 | CalculateContactsToCompoundContinue (dgCollidingPairCollector::dgPair *const pair, dgCollisionParamProxy &proxy) const
dgInt32 | CalculateContactsToCollisionTree (dgCollidingPairCollector::dgPair *const pair, dgCollisionParamProxy &proxy) const
dgInt32 | CalculateContactsToCollisionTreeContinue (dgCollidingPairCollector::dgPair *const pair, dgCollisionParamProxy &proxy) const
dgInt32 | CalculateContactsToHeightField (dgCollidingPairCollector::dgPair *const pair, dgCollisionParamProxy &proxy) const
dgInt32 | CalculateContactsUserDefinedCollision (dgCollidingPairCollector::dgPair *const pair, dgCollisionParamProxy &proxy) const
dgFloat32 | ConvexRayCastSingleConvex (const dgCollisionInstance *const convexInstance, const dgMatrix &instanceMatrix, const dgVector &instanceVeloc, dgFloat32 maxT, dgContactPoint &contactOut, const dgBody *const referenceBody, const dgCollisionInstance *const referenceInstance, void *const userData, dgInt32 threadId) const
dgInt32 | ClosestDistance (dgCollisionParamProxy &proxy) const
dgInt32 | ClosestDistanceToConvex (dgCollisionParamProxy &proxy) const
dgInt32 | ClosestDistanceToCompound (dgCollisionParamProxy &proxy) const
dgNodeBase * | BuildTopDown (dgNodeBase **const leafArray, dgInt32 firstBox, dgInt32 lastBox, dgList< dgNodeBase *>::dgListNode **const nextNode)
dgFloat64 | CalculateEntropy (dgList< dgNodeBase *> &list)
void | ImproveNodeFitness (dgNodeBase *const node) const
dgFloat32 | CalculateSurfaceArea (dgNodeBase *const node0, dgNodeBase *const node1, dgVector &minBox, dgVector &maxBox) const
dgInt32 | CalculatePlaneIntersection (const dgVector &normal, const dgVector &point, dgVector *const contactsOut, dgFloat32 normalSign) const
void | PushNode (const dgMatrix &matrix, dgUpHeap< dgHeapNodePair, dgFloat32 > &heap, dgNodeBase *const myNode, dgNodeBase *const otehrNode) const
Protected Member Functions inherited from dgCollision
| dgCollision (const dgCollision &source)
| dgCollision (dgMemoryAllocator *const allocator, dgUnsigned32 signature, dgCollisionID id)
| dgCollision (dgWorld *const world, dgDeserialize deserialization, void *const userData)
virtual | ~dgCollision ()
void | SetSignature (dgInt32 signature)
Static Protected Member Functions inherited from dgCollisionCompound
static void | CalculateInertia (void *userData, int vertexCount, const dgFloat32 *const FaceArray, int faceId)
Protected Attributes inherited from dgCollisionCompound
dgFloat32 | m_boxMinRadius
dgFloat32 | m_boxMaxRadius
dgFloat64 | m_treeEntropy
dgWorld * | m_world
dgNodeBase * | m_root
const dgCollisionInstance * | m_myInstance
dgThread::dgCriticalSection | m_criticalSectionLock
dgTreeArray | m_array
dgInt32 | m_idIndex
Protected Attributes inherited from dgCollision
dgVector | m_inertia
dgVector | m_crossInertia
dgVector | m_centerOfMass
dgVector | m_boxSize
dgVector | m_boxOrigin
dgInt32 | m_rtti
dgInt32 | m_refCount
dgUnsigned32 | m_signature
dgCollisionID | m_collisionId
dgMemoryAllocator * | m_allocator
Static Protected Attributes inherited from dgCollisionCompound
static dgVector | m_padding

## Constructor & Destructor Documentation

## § dgCollisionScene() [1/3]

dgCollisionScene::dgCollisionScene | ( | dgWorld *const | world | ) |

## § dgCollisionScene() [2/3]

dgCollisionScene::dgCollisionScene | ( | const dgCollisionScene & | source,
|  | const dgCollisionInstance *const | myInstance
| ) |  |

## § dgCollisionScene() [3/3]

dgCollisionScene::dgCollisionScene | ( | dgWorld *const | world,
|  | dgDeserialize | deserialization,
|  | void *const | userData,
|  | const dgCollisionInstance *const | myInstance
| ) |  |

## § ~dgCollisionScene()

dgCollisionScene::~dgCollisionScene | ( |  | ) |

virtual

## Member Function Documentation

## § CollideCompoundPair()

void dgCollisionScene::CollideCompoundPair | ( | dgCollidingPairCollector::dgPair *const | pair,
|  | dgCollisionParamProxy & | proxy
| ) |  | const

## § CollidePair()

void dgCollisionScene::CollidePair | ( | dgCollidingPairCollector::dgPair *const | pair,
|  | dgCollisionParamProxy & | proxy
| ) |  | const

## § GetBoxMaxRadius()

dgFloat32 dgCollisionScene::GetBoxMaxRadius | ( |  | ) | const

virtual

Reimplemented from dgCollisionCompound.

## § GetBoxMinRadius()

dgFloat32 dgCollisionScene::GetBoxMinRadius | ( |  | ) | const

virtual

Reimplemented from dgCollisionCompound.

## § MassProperties()

void dgCollisionScene::MassProperties | ( |  | ) |

virtual

Reimplemented from dgCollisionCompound.

## § Serialize()

void dgCollisionScene::Serialize | ( | dgSerialize | callback,
|  | void *const | userData
| ) |  | const

virtual

Reimplemented from dgCollisionCompound.

The documentation for this class was generated from the following files:

- dynamics.mod/NewtonDynamics/source/physics/dgCollisionScene.h
- dynamics.mod/NewtonDynamics/source/physics/dgCollisionScene.cpp